package com.alibaba.tesseract.page.events.site;

import android.text.TextUtils;

import com.alibaba.android.tesseract.core.event.TesseractBaseSubscriber;
import com.alibaba.android.tesseract.core.event.base.TesseractEvent;
import com.alibaba.android.tesseract.sdk.common.model.IDMEvent;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.gov.android.api.site.ISiteMidService;
import com.alibaba.gov.android.api.site.SiteModel;
import com.alibaba.gov.android.api.site.SiteSelectionCallback;
import com.alibaba.gov.android.common.config.AppConfig;
import com.alibaba.gov.android.servicebus.manager.ServiceManager;
import com.alibaba.tesseract.page.events.RefreshPageEvent;

import org.greenrobot.eventbus.EventBus;

import java.util.HashMap;
import java.util.Map;

import static com.alibaba.tesseract.page.activity.Constants.REQUEST_TYPE_SITE_CHANGE;

/**
 * Created by yiwei on 2020-07-10.
 */
public class SiteSwitchEventSubscriber extends TesseractBaseSubscriber {
    public static final String EVENT_TAG = "switchSite";

    @Override
    protected void onHandleEvent(final TesseractEvent tesseractEvent) {
        if (tesseractEvent == null || tesseractEvent.getContext() == null) {
            return;
        }
        IDMEvent idmEvent = this.getIDMEvent();
        if (idmEvent == null) {
            return;
        }
        JSONObject fields = idmEvent.getFields();
        if (fields == null) {
            return;
        }
        String siteId = fields.getString("siteId");
        String siteParentUrl= AppConfig.getString("baseHost") + "/app_api/refinedDistrict/queryDistrictPathById?code=";
        String siteUrl = AppConfig.getString("baseHost") + "/app_api/refinedDistrict/queryChildDistrictByid?parentCode=";

        new SiteSwitchHelper(mContext, siteId, 0, siteUrl, siteParentUrl, 0, 3)
                .startSiteMidBySearchResult(new SiteSelectionCallback() {
                    @Override
                    public void result(SiteModel siteModel, String adCode) {
                        String siteId = adCode;
                        if (siteModel != null && !TextUtils.isEmpty(siteModel.code)) {
                            siteId = siteModel.code;
                        }
                        JSONObject params = new JSONObject();
                        params.put("siteId", siteId);
                        EventBus.getDefault().post(new RefreshPageEvent(tesseractEvent.getTesseractCore().getBizName(), REQUEST_TYPE_SITE_CHANGE, params));
                    }
                });
    }
}
