package com.alibaba.tesseract.page.manager;

import com.alibaba.gov.android.api.tesseractpage.ITesseractActivity;
import com.alibaba.gov.android.api.tesseractpage.ITesseractRouter;
import com.alibaba.tesseract.page.inter.ITesseractFragment;
import com.alibaba.tesseract.page.inter.ITesseractPage;

/**
 * Created by yiwei on 2020-10-03.
 */
public class TesseractPageManager implements ITesseractPage {
    private static TesseractPageManager mServiceInstance = null;

    private TesseractPageManager() {
    }


    public static TesseractPageManager getInstance() {
        if (mServiceInstance == null) {
            mServiceInstance = new TesseractPageManager();
        }
        return mServiceInstance;
    }

    @Override
    public ITesseractFragment getFragmentManager() {
        return new TesseractFragmentManager();
    }

    @Override
    public ITesseractActivity getActivityManager() {
        return new TesseractActivityManager();
    }

    @Override
    public ITesseractRouter getTesseractRouter() {
        return new TesseractRouter();
    }
}
