package com.alibaba.tesseract.page.utils;


import com.alibaba.android.tesseract.core.event.base.ISubscriber;
import com.alibaba.android.tesseract.core.event.base.TesseractEventHandler;
import com.alibaba.android.tesseract.core.instance.ITesseractInstance;
import com.alibaba.tesseract.page.events.DXDxZWCountDownFinishEventHandler;
import com.alibaba.tesseract.page.events.DXPropsEventHandler;
import com.alibaba.tesseract.page.events.DXRefreshEventHandler;
import com.alibaba.tesseract.page.events.DXZWInputOnChangeEventHandler;
import com.alibaba.tesseract.page.events.DXZwScrollEndEventHandler;
import com.alibaba.tesseract.page.events.site.SiteSwitchEventSubscriber;
import com.alibaba.tesseract.page.events.ZWOpenUrlEventHandler;
import com.alibaba.tesseract.page.parsers.DXDataParserZwContainerHeight;
import com.alibaba.tesseract.page.view.DXZWCountDownViewWidgetNode;

import java.util.Map;


/**
 * Created by yiwei on 2020-10-02.
 */
public class BaseSubscribeUtil {

    public static void initEventSubsriber(ITesseractInstance tesseractInstance, Map<String, ISubscriber> eventSubscriber) {
        if (tesseractInstance == null) {
            return;
        }
        tesseractInstance.registDXDataParser(DXDataParserZwContainerHeight.DX_PARSER_ZWCONTAINERHEIGHT, new DXDataParserZwContainerHeight());
        tesseractInstance.registDXEventHanlder(DXZwScrollEndEventHandler.DX_EVENT_ZWSCROLLEND, new DXZwScrollEndEventHandler());
        tesseractInstance.registDXEventHanlder(DXPropsEventHandler.DX_EVENT_PROPS, new DXPropsEventHandler());
        tesseractInstance.registDXEventHanlder(ZWOpenUrlEventHandler.TAG_ID, new ZWOpenUrlEventHandler());
        tesseractInstance.registDXEventHanlder(DXZWInputOnChangeEventHandler.DX_EVENT_ZWINPUTONCHANGE, new DXZWInputOnChangeEventHandler());
        tesseractInstance.registDXEventHanlder(DXDxZWCountDownFinishEventHandler.DX_EVENT_DXZWCOUNTDOWNFINISH, new DXDxZWCountDownFinishEventHandler());
        tesseractInstance.registDXEventHanlder(DXRefreshEventHandler.DX_EVENT_REFRESH, new DXRefreshEventHandler());

        TesseractEventHandler eventHandler = tesseractInstance.getEventHandler();
        if (eventHandler == null) {
            return;
        }
        if (eventSubscriber != null && eventSubscriber.size() > 0) {
            eventHandler.addSubscribers(eventSubscriber);
        }
        addDefaultEventSubscriber(eventHandler);
        initView(tesseractInstance);
    }


    private static void initView(ITesseractInstance tesseractInstance) {
        tesseractInstance.registDXView(DXZWCountDownViewWidgetNode.DXZWCOUNTDOWNVIEW_ZWCOUNTDOWNVIEW, new DXZWCountDownViewWidgetNode());
    }

    private static void addDefaultEventSubscriber(TesseractEventHandler eventHandler) {
        eventHandler.addSubscriber(SiteSwitchEventSubscriber.EVENT_TAG, new SiteSwitchEventSubscriber());
    }
}
